Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 74)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 75)
@@ -9,9 +9,10 @@
 ! Arrays for radiation boundary conditions are allocated (u_m_l, u_m_r, etc.),
 ! bugfix for cases with the outflow damping layer extending over more than one
-! subdomain,
-! New initializing action "by_user" calls user_init_3d_model,
+! subdomain, moisture renamed humidity,
+! new initializing action "by_user" calls user_init_3d_model,
 ! precipitation_amount/rate, ts_value are allocated, +module netcdf_control,
 ! initial velocities at nzb+1 are regarded for volume
 ! flow control in case they have been set zero before (to avoid small timesteps)
+! -uvmean_outflow, uxrp, vynp eliminated
 !
 ! Former revisions:
@@ -76,6 +77,5 @@
               sums_divnew_l(0:statistic_regions),                           &
               sums_divold_l(0:statistic_regions) )
-    ALLOCATE( rdf(nzb+1:nzt), uvmean_outflow(nzb:nzt+1),                    &
-              uvmean_outflow_l(nzb:nzt+1) )
+    ALLOCATE( rdf(nzb+1:nzt) )
     ALLOCATE( hom_sum(nzb:nzt+1,var_hom,0:statistic_regions),               &
               ngp_2dh_outer(nzb:nzt+1,0:statistic_regions),                 &
@@ -105,23 +105,23 @@
     ENDIF
 
-    ALLOCATE( d(nzb+1:nzta,nys:nyna,nxl:nxra),             &
-              e_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
-              e_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
-              e_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
-              kh_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
-              km_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
-              p(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),        &
-              pt_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
-              pt_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
-              pt_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
-              tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
-              u_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1+uxrp), &
-              u_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1+uxrp), &
-              u_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1+uxrp), &
-              v_1(nzb:nzt+1,nys-1:nyn+1+vynp,nxl-1:nxr+1), &
-              v_2(nzb:nzt+1,nys-1:nyn+1+vynp,nxl-1:nxr+1), &
-              v_3(nzb:nzt+1,nys-1:nyn+1+vynp,nxl-1:nxr+1), &
-              w_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
-              w_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
+    ALLOCATE( d(nzb+1:nzta,nys:nyna,nxl:nxra),         &
+              e_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
+              e_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
+              e_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
+              kh_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              km_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              p(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),    &
+              pt_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              pt_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              pt_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              u_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
+              u_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
+              u_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
+              v_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              v_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              v_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+              w_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
+              w_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
               w_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
 
@@ -131,7 +131,7 @@
     ENDIF
 
-    IF ( moisture  .OR.  passive_scalar ) THEN
-!
-!--    2D-moisture/scalar arrays
+    IF ( humidity  .OR.  passive_scalar ) THEN
+!
+!--    2D-humidity/scalar arrays
        ALLOCATE ( qs(nys-1:nyn+1,nxl-1:nxr+1),     &
                   qsws_1(nys-1:nyn+1,nxl-1:nxr+1), &
@@ -143,5 +143,5 @@
        ENDIF
 !
-!--    3D-moisture/scalar arrays
+!--    3D-humidity/scalar arrays
        ALLOCATE( q_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
                  q_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
@@ -149,6 +149,6 @@
 
 !
-!--    3D-arrays needed for moisture only
-       IF ( moisture )  THEN
+!--    3D-arrays needed for humidity only
+       IF ( humidity )  THEN
           ALLOCATE( vpt_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
 
@@ -212,22 +212,22 @@
 !-- conditions
     IF ( outflow_l )  THEN
-       ALLOCATE( u_m_l(nzb:nzt+1,nys-1:nyn+1,-1:1,-2:-1), &
-                 v_m_l(nzb:nzt+1,nys-1:nyn+1,-1:1,-2:-1), &
-                 w_m_l(nzb:nzt+1,nys-1:nyn+1,-1:1,-2:-1) )
+       ALLOCATE( u_m_l(nzb:nzt+1,nys-1:nyn+1,-1:1), &
+                 v_m_l(nzb:nzt+1,nys-1:nyn+1,-1:1), &
+                 w_m_l(nzb:nzt+1,nys-1:nyn+1,-1:1) )
     ENDIF
     IF ( outflow_r )  THEN
-       ALLOCATE( u_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx+1,-2:-1), &
-                 v_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx+1,-2:-1), &
-                 w_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx+1,-2:-1) )
+       ALLOCATE( u_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx+1), &
+                 v_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx+1), &
+                 w_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx+1) )
     ENDIF
     IF ( outflow_s )  THEN
-       ALLOCATE( u_m_s(nzb:nzt+1,-1:1,nxl-1:nxr+1,-2:-1), &
-                 v_m_s(nzb:nzt+1,-1:1,nxl-1:nxr+1,-2:-1), &
-                 w_m_s(nzb:nzt+1,-1:1,nxl-1:nxr+1,-2:-1) )
+       ALLOCATE( u_m_s(nzb:nzt+1,-1:1,nxl-1:nxr+1), &
+                 v_m_s(nzb:nzt+1,-1:1,nxl-1:nxr+1), &
+                 w_m_s(nzb:nzt+1,-1:1,nxl-1:nxr+1) )
     ENDIF
     IF ( outflow_n )  THEN
-       ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny+1,nxl-1:nxr+1,-2:-1), &
-                 v_m_n(nzb:nzt+1,ny-1:ny+1,nxl-1:nxr+1,-2:-1), &
-                 w_m_n(nzb:nzt+1,ny-1:ny+1,nxl-1:nxr+1,-2:-1) )
+       ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny+1,nxl-1:nxr+1), &
+                 v_m_n(nzb:nzt+1,ny-1:ny+1,nxl-1:nxr+1), &
+                 w_m_n(nzb:nzt+1,ny-1:ny+1,nxl-1:nxr+1) )
     ENDIF
 
@@ -249,9 +249,9 @@
        w_m  => w_1;   w  => w_2;   w_p  => w_3;   tw_m  => w_3
 
-       IF ( moisture  .OR.  passive_scalar )  THEN
+       IF ( humidity  .OR.  passive_scalar )  THEN
           qsws_m  => qsws_1;   qsws  => qsws_2
           qswst_m => qswst_1;  qswst => qswst_2
           q_m    => q_1;     q    => q_2;     q_p => q_3;     tq_m => q_3
-          IF ( moisture )        vpt_m  => vpt_1;   vpt  => vpt_2
+          IF ( humidity )        vpt_m  => vpt_1;   vpt  => vpt_2
           IF ( cloud_physics )   ql   => ql_1
           IF ( cloud_droplets )  THEN
@@ -276,9 +276,9 @@
        w     => w_1;   w_p  => w_2;   tw_m  => w_3;   w_m  => w_3
 
-       IF ( moisture  .OR.  passive_scalar )  THEN
+       IF ( humidity  .OR.  passive_scalar )  THEN
           qsws   => qsws_1
           qswst  => qswst_1
           q      => q_1;     q_p  => q_2;     tq_m => q_3;    q_m => q_3
-          IF ( moisture )        vpt  => vpt_1
+          IF ( humidity )        vpt  => vpt_1
           IF ( cloud_physics )   ql   => ql_1
           IF ( cloud_droplets )  THEN
@@ -309,18 +309,10 @@
                 km(:,j,i) = km1d
                 pt(:,j,i) = pt_init
-             ENDDO
-          ENDDO
-          DO  i = nxl-1, nxr+uxrp+1
-             DO  j = nys-1, nyn+1
                 u(:,j,i)  = u1d
-             ENDDO
-          ENDDO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+vynp+1
                 v(:,j,i)  = v1d
              ENDDO
           ENDDO
 
-          IF ( moisture  .OR.  passive_scalar )  THEN
+          IF ( humidity  .OR.  passive_scalar )  THEN
              DO  i = nxl-1, nxr+1
                 DO  j = nys-1, nyn+1
@@ -368,5 +360,5 @@
 !--       This could actually be computed more accurately in the 1D model.
 !--       Update when opportunity arises!
-          IF ( moisture  .OR.  passive_scalar )  qs = 0.0
+          IF ( humidity  .OR.  passive_scalar )  qs = 0.0
 
 !
@@ -419,16 +411,9 @@
              DO  j = nys-1, nyn+1
                 pt(:,j,i) = pt_init
-             ENDDO
-          ENDDO
-          DO  i = nxl-1, nxr+uxrp+1
-             DO  j = nys-1, nyn+1
                 u(:,j,i)  = u_init
-             ENDDO
-          ENDDO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+vynp+1
                 v(:,j,i)  = v_init
              ENDDO
           ENDDO
+
 !
 !--       Set initial horizontal velocities at the lowest computational grid levels
@@ -458,5 +443,5 @@
           ENDIF
 
-          IF ( moisture  .OR.  passive_scalar )  THEN
+          IF ( humidity  .OR.  passive_scalar )  THEN
              DO  i = nxl-1, nxr+1
                 DO  j = nys-1, nyn+1
@@ -482,5 +467,5 @@
           usws = 0.0
           vsws = 0.0
-          IF ( moisture  .OR.  passive_scalar ) qs = 0.0
+          IF ( humidity  .OR.  passive_scalar ) qs = 0.0
 
 !
@@ -499,5 +484,5 @@
 !
 !--    Calculate virtual potential temperature
-       IF ( moisture ) vpt = pt * ( 1.0 + 0.61 * q )
+       IF ( humidity ) vpt = pt * ( 1.0 + 0.61 * q )
 
 !
@@ -515,5 +500,5 @@
 
 
-       IF ( moisture )  THEN
+       IF ( humidity )  THEN
 !
 !--       Store initial profile of total water content, virtual potential
@@ -564,5 +549,5 @@
 !
 !--       Determine the near-surface water flux
-          IF ( moisture  .OR.  passive_scalar )  THEN
+          IF ( humidity  .OR.  passive_scalar )  THEN
              IF ( constant_waterflux )  THEN
                 qsws   = surface_waterflux
@@ -585,5 +570,5 @@
              IF ( ASSOCIATED( tswst_m ) )  tswst_m = tswst
 
-             IF ( moisture  .OR.  passive_scalar )  THEN
+             IF ( humidity  .OR.  passive_scalar )  THEN
                 qswst = 0.0
                 IF ( ASSOCIATED( qswst_m ) )  qswst_m = qswst
@@ -610,5 +595,5 @@
           ENDIF
 
-          IF ( moisture  .OR.  passive_scalar )  THEN
+          IF ( humidity  .OR.  passive_scalar )  THEN
              IF ( .NOT. constant_waterflux )  THEN
                 qsws   = 0.0
@@ -709,5 +694,5 @@
 !--    If required, change the surface humidity/scalar at the start of the 3D
 !--    run
-       IF ( ( moisture .OR. passive_scalar ) .AND. &
+       IF ( ( humidity .OR. passive_scalar ) .AND. &
             q_surface_initial_change /= 0.0 )  THEN
           q(nzb,:,:) = q(nzb,:,:) + q_surface_initial_change
@@ -722,6 +707,6 @@
 !--    remove the divergences from the velocity field
        IF ( create_disturbances )  THEN
-          CALL disturb_field( nzb_u_inner, tend, u, uxrp,    0 )
-          CALL disturb_field( nzb_v_inner, tend, v,    0, vynp )
+          CALL disturb_field( nzb_u_inner, tend, u )
+          CALL disturb_field( nzb_v_inner, tend, v )
           n_sor = nsor_ini
           CALL pres
@@ -746,9 +731,9 @@
        e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
 
-       IF ( moisture  .OR.  passive_scalar )  THEN
+       IF ( humidity  .OR.  passive_scalar )  THEN
           IF ( ASSOCIATED( q_m ) )  q_m = q
           IF ( timestep_scheme(1:5) == 'runge' )  tq_m = 0.0
           q_p = q
-          IF ( moisture  .AND.  ASSOCIATED( vpt_m ) )  vpt_m = vpt
+          IF ( humidity  .AND.  ASSOCIATED( vpt_m ) )  vpt_m = vpt
        ENDIF
 
@@ -756,34 +741,22 @@
 !--    Initialize old timelevels needed for radiation boundary conditions
        IF ( outflow_l )  THEN
-          u_m_l(:,:,:,-2) = u(:,:,-1:1)
-          v_m_l(:,:,:,-2) = v(:,:,-1:1)
-          w_m_l(:,:,:,-2) = w(:,:,-1:1)
-          u_m_l(:,:,:,-1) = u(:,:,-1:1)
-          v_m_l(:,:,:,-1) = v(:,:,-1:1)
-          w_m_l(:,:,:,-1) = w(:,:,-1:1)
+          u_m_l(:,:,:) = u(:,:,-1:1)
+          v_m_l(:,:,:) = v(:,:,-1:1)
+          w_m_l(:,:,:) = w(:,:,-1:1)
        ENDIF
        IF ( outflow_r )  THEN
-          u_m_r(:,:,:,-2) = u(:,:,nx-1:nx+1)
-          v_m_r(:,:,:,-2) = v(:,:,nx-1:nx+1)
-          w_m_r(:,:,:,-2) = w(:,:,nx-1:nx+1)
-          u_m_r(:,:,:,-1) = u(:,:,nx-1:nx+1)
-          v_m_r(:,:,:,-1) = v(:,:,nx-1:nx+1)
-          w_m_r(:,:,:,-1) = w(:,:,nx-1:nx+1)
+          u_m_r(:,:,:) = u(:,:,nx-1:nx+1)
+          v_m_r(:,:,:) = v(:,:,nx-1:nx+1)
+          w_m_r(:,:,:) = w(:,:,nx-1:nx+1)
        ENDIF
        IF ( outflow_s )  THEN
-          u_m_s(:,:,:,-2) = u(:,-1:1,:)
-          v_m_s(:,:,:,-2) = v(:,-1:1,:)
-          w_m_s(:,:,:,-2) = w(:,-1:1,:)
-          u_m_s(:,:,:,-1) = u(:,-1:1,:)
-          v_m_s(:,:,:,-1) = v(:,-1:1,:)
-          w_m_s(:,:,:,-1) = w(:,-1:1,:)
+          u_m_s(:,:,:) = u(:,-1:1,:)
+          v_m_s(:,:,:) = v(:,-1:1,:)
+          w_m_s(:,:,:) = w(:,-1:1,:)
        ENDIF
        IF ( outflow_n )  THEN
-          u_m_n(:,:,:,-2) = u(:,ny-1:ny+1,:)
-          v_m_n(:,:,:,-2) = v(:,ny-1:ny+1,:)
-          w_m_n(:,:,:,-2) = w(:,ny-1:ny+1,:)
-          u_m_n(:,:,:,-1) = u(:,ny-1:ny+1,:)
-          v_m_n(:,:,:,-1) = v(:,ny-1:ny+1,:)
-          w_m_n(:,:,:,-1) = w(:,ny-1:ny+1,:)
+          u_m_n(:,:,:) = u(:,ny-1:ny+1,:)
+          v_m_n(:,:,:) = v(:,ny-1:ny+1,:)
+          w_m_n(:,:,:) = w(:,ny-1:ny+1,:)
        ENDIF
 
@@ -803,5 +776,5 @@
 !--    including ghost points)
        e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
-       IF ( moisture  .OR.  passive_scalar )  q_p = q
+       IF ( humidity  .OR.  passive_scalar )  q_p = q
 
     ELSE
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 74)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 75)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! storage of topography height arrays zu_s_inner and zw_s_inner
+! storage of topography height arrays zu_s_inner and zw_s_inner,
+! 2nd+3rd argument removed from exchange horiz
 !
 ! Former revisions:
@@ -823,5 +824,5 @@
 !
 !-- Need to set lateral boundary conditions for l_wall
-    CALL exchange_horiz( l_wall, 0, 0 )
+    CALL exchange_horiz( l_wall )
 
     DEALLOCATE( corner_nl, corner_nr, corner_sl, corner_sr, nzb_local, &
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 74)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 75)
@@ -5,5 +5,6 @@
 ! -----------------
 ! uxrp, vynp eliminated,
-! dirichlet/neumann changed to dirichlet/radiation, etc.
+! dirichlet/neumann changed to dirichlet/radiation, etc.,
+! poisfft_init is only called if fft-solver is switched on
 !
 ! Former revisions:
@@ -493,9 +494,4 @@
     nzta = nz
     nnz  = nz
-
-!
-!-- For non-cyclic boundaries extend array u (v) by one gridpoint
-!    IF ( bc_lr /= 'cyclic' )  uxrp = 1
-!    IF ( bc_ns /= 'cyclic' )  vynp = 1
 
 !
@@ -757,5 +753,4 @@
           inflow_r  = .TRUE.
        ENDIF
-!       uxrp      = 1
     ENDIF
 
@@ -774,22 +769,10 @@
           outflow_n = .TRUE.
        ENDIF
-!       vynp      = 1
-    ENDIF
-
-!
-!-- Additional MPI derived data type for the exchange of ghost points along x
-!-- needed in case of non-cyclic boundary conditions along y on the northmost
-!-- processors (for the exchange of the enlarged v array)
-    IF ( bc_ns /= 'cyclic'  .AND.  pnorth == MPI_PROC_NULL )  THEN
-       ngp_yz_p = ( nzt - nzb + 2 ) * ( nyn + vynp - nys + 3 )
-       CALL MPI_TYPE_VECTOR( nxr-nxl+3, nzt-nzb+2, ngp_yz_p, &
-                             MPI_REAL, type_xz_p, ierr )
-       CALL MPI_TYPE_COMMIT( type_xz_p, ierr )
-    ENDIF
+    ENDIF
+
 #else
     IF ( bc_lr == 'dirichlet/radiation' )  THEN
        inflow_l  = .TRUE.
        outflow_r = .TRUE.
-!       uxrp      = 1
     ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
        outflow_l = .TRUE.
@@ -803,5 +786,4 @@
        outflow_n = .TRUE.
        inflow_s  = .TRUE.
-!       vynp      = 1
     ENDIF
 #endif
@@ -809,5 +791,5 @@
     IF ( psolver == 'poisfft_hybrid' )  THEN
        CALL poisfft_hybrid_ini
-    ELSE
+    ELSEIF ( psolver == 'poisfft' )  THEN
        CALL poisfft_init
     ENDIF
Index: palm/trunk/SOURCE/init_pt_anomaly.f90
===================================================================
--- palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 74)
+++ palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 75)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! 2nd+3rd argument removed from exchange horiz
 !
 ! Former revisions:
@@ -70,5 +70,5 @@
 !
 !-- Exchange of boundary values for temperature
-    CALL exchange_horiz( pt, 0, 0 )
+    CALL exchange_horiz( pt )
 
 
Index: palm/trunk/SOURCE/init_rankine.f90
===================================================================
--- palm/trunk/SOURCE/init_rankine.f90	(revision 74)
+++ palm/trunk/SOURCE/init_rankine.f90	(revision 75)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! uxrp, vynp eliminated, 2nd+3rd argument removed from exchange horiz
 !
 ! Former revisions:
@@ -129,6 +129,6 @@
 !
 !-- Exchange of boundary values for the velocities.
-    CALL exchange_horiz( u, uxrp,    0 )
-    CALL exchange_horiz( v,    0, vynp )
+    CALL exchange_horiz( u )
+    CALL exchange_horiz( v )
 !
 !-- Make velocity field nondivergent.
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 74)
+++ palm/trunk/SOURCE/modules.f90	(revision 75)
@@ -9,8 +9,9 @@
 ! +loop_optimization, netcdf_64bit_3d, zu_s_inner, zw_w_inner, id_var_zusi_*,
 ! id_var_zwwi_*, ts_value, u_nzb_p1_for_vfc, v_nzb_p1_for_vfc, pt_reference,
-! use_pt_reference, precipitation_amount_interval
-! +age_m in particle_type
-! -data_output_ts, dots_n
-! arrays dots_label and dots_unit now dimensioned with dots_max
+! use_pt_reference, precipitation_amount_interval, revision
+! +age_m in particle_type, moisture renamed humidity,
+! -data_output_ts, dots_n, uvmean_outflow, uxrp, vynp,
+! arrays dots_label and dots_unit now dimensioned with dots_max,
+! setting of palm version moved to main program
 !
 ! Former revisions:
@@ -81,6 +82,6 @@
     REAL, DIMENSION(:), ALLOCATABLE ::                                         &
           ddzu, dd2zu, dzu, ddzw, dzw, km_damp_x, km_damp_y, l_grid, pt_init,  &
-          q_init, rdf, ug, uvmean_outflow, uvmean_outflow_l, u_init,           &
-          u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, zu, zw
+          q_init, rdf, ug, u_init, u_nzb_p1_for_vfc, vg, v_init,               &
+          v_nzb_p1_for_vfc, zu, zw
 
     REAL, DIMENSION(:,:), ALLOCATABLE ::                                       &
@@ -96,5 +97,6 @@
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE ::                                     &
-          d, diss, l_wall, tend
+          d, diss, l_wall, tend, u_m_l, u_m_n, u_m_r, u_m_s, v_m_l, v_m_n,     &
+          v_m_r, v_m_s, w_m_l, w_m_n, w_m_r, w_m_s
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                             &
@@ -111,7 +113,5 @@
           vpt, vpt_m, w, w_m, w_p
 
-    REAL, DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall, u_m_l, u_m_n, u_m_r,   &
-          u_m_s, v_m_l, v_m_n, v_m_r, v_m_s, w_m_l, w_m_n, w_m_r, w_m_s
-                                                    
+    REAL, DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall
 
     SAVE
@@ -217,5 +217,5 @@
     CHARACTER (LEN=8)   ::  run_date, run_time
     CHARACTER (LEN=9)   ::  simulated_time_chr
-    CHARACTER (LEN=12)  ::  version = 'PALM   3.2'
+    CHARACTER (LEN=12)  ::  version = ' ', revision = ' '
     CHARACTER (LEN=16)  ::  loop_optimization = 'default', &
                             momentum_advec = 'pw-scheme', &
@@ -236,6 +236,6 @@
     CHARACTER (LEN=40)  ::  avs_data_file, topography = 'flat'
     CHARACTER (LEN=64)  ::  host
-    CHARACTER (LEN=80)  ::  log_message, run_description_header, run_identifier
-    CHARACTER (LEN=100) ::  initializing_actions = ' '
+    CHARACTER (LEN=80)  ::  log_message, run_identifier
+    CHARACTER (LEN=100) ::  initializing_actions = ' ', run_description_header
 
     CHARACTER (LEN=7),  DIMENSION(100) ::  do3d_comp_prec = ' '
@@ -293,7 +293,7 @@
                 first_call_advec_particles = .TRUE., &
                 force_print_header = .FALSE., galilei_transformation = .FALSE.,&
-                inflow_l = .FALSE., inflow_n = .FALSE., inflow_r = .FALSE., &
-                inflow_s = .FALSE., iso2d_output = .FALSE., &
-                mg_switch_to_pe0 = .FALSE., moisture = .FALSE., &
+                humidity = .FALSE., inflow_l = .FALSE., inflow_n = .FALSE., &
+                inflow_r = .FALSE., inflow_s = .FALSE., iso2d_output = .FALSE.,&
+                mg_switch_to_pe0 = .FALSE., &
                 netcdf_output = .FALSE., netcdf_64bit = .FALSE., &
                 netcdf_64bit_3d = .TRUE., &
@@ -528,5 +528,5 @@
     INTEGER ::  ngp_sums, nnx, nx = 0, nxa, nxl, nxr, nxra, nny, ny = 0, nya,  &
                 nyn, nyna, nys, nnz, nz = 0, nza, nzb, nzb_diff, nzt, nzta,    &
-                nzt_diff, uxrp = 0, vynp = 0
+                nzt_diff
 
     INTEGER, DIMENSION(:), ALLOCATABLE ::                                      &
@@ -889,8 +889,8 @@
 #if defined( __parallel )
     INTEGER ::  comm1dx, comm1dy, comm2d, comm_palm, ierr, myidx, myidy,       &
-                ndim = 2, ngp_y, ngp_yz_p, pleft, pnorth, pright, psouth,      &
+                ndim = 2, ngp_y, pleft, pnorth, pright, psouth,                &
                 sendrecvcount_xy, sendrecvcount_yz, sendrecvcount_zx,          &
                 sendrecvcount_zyd, sendrecvcount_yxd,                          &
-                type_x, type_x_int, type_xz_p, ibuf(12), pcoord(2), pdims(2),  &
+                type_x, type_x_int, ibuf(12), pcoord(2), pdims(2),             &
                 status(MPI_STATUS_SIZE)
 
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 74)
+++ palm/trunk/SOURCE/palm.f90	(revision 75)
@@ -5,5 +5,6 @@
 ! -----------------
 ! __vtk directives removed, write_particles is called only in case of particle
-! advection switched on, open unit 9 for debug output
+! advection switched on, open unit 9 for debug output,
+! setting of palm version moved from modules to here
 !
 ! Former revisions:
@@ -57,4 +58,6 @@
     CHARACTER (LEN=1) ::  cdum
     INTEGER           ::  i, run_description_header_i(80)
+
+    version = 'PALM 3.2'
 
 #if defined( __parallel )
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 74)
+++ palm/trunk/SOURCE/parin.f90	(revision 75)
@@ -5,5 +5,6 @@
 ! -----------------
 ! +dt_max, netcdf_64bit_3d, precipitation_amount_interval in d3par,
-! +loop_optimization, pt_reference in inipar, -data_output_ts
+! +loop_optimization, pt_reference in inipar, -data_output_ts,
+! moisture renamed humidity
 !
 ! Former revisions:
@@ -58,8 +59,8 @@
                        dz_stretch_factor, dz_stretch_level, e_min, &
                        end_time_1d, fft_method, galilei_transformation, &
-                       grid_matching, inflow_disturbance_begin, &
+                       grid_matching, humidity, inflow_disturbance_begin, &
                        inflow_disturbance_end, initializing_actions, &
                        km_constant, km_damp_max, long_filter_factor, &
-                       loop_optimization, mixing_length_1d, moisture, &
+                       loop_optimization, mixing_length_1d, &
                        momentum_advec, netcdf_precision, npex, npey, nsor_ini, &
                        nx, ny, nz, omega, outflow_damping_width, &
@@ -117,6 +118,6 @@
 
 
-    NAMELIST /envpar/  host, maximum_cpu_time_allowed, run_identifier, &
-                       tasks_per_node, write_binary
+    NAMELIST /envpar/  host, maximum_cpu_time_allowed, revision, &
+                       run_identifier, tasks_per_node, write_binary
 
 
Index: palm/trunk/SOURCE/poismg.f90
===================================================================
--- palm/trunk/SOURCE/poismg.f90	(revision 74)
+++ palm/trunk/SOURCE/poismg.f90	(revision 75)
@@ -8,5 +8,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! 2nd+3rd argument removed from exchange horiz
 !
 ! Former revisions:
@@ -59,5 +59,5 @@
 !
 !-- Some boundaries have to be added to divergence array
-    CALL exchange_horiz( d, 0, 0 )
+    CALL exchange_horiz( d )
     d(nzb,:,:) = d(nzb+1,:,:)
 
@@ -164,5 +164,5 @@
 !
 !-- Horizontal boundary conditions
-    CALL exchange_horiz( r, 0, 0 )
+    CALL exchange_horiz( r )
 
     IF ( bc_lr /= 'cyclic' )  THEN
@@ -257,5 +257,5 @@
 !
 !-- Horizontal boundary conditions
-    CALL exchange_horiz( f_mg, 0, 0 )
+    CALL exchange_horiz( f_mg )
 
     IF ( bc_lr /= 'cyclic' )  THEN
@@ -355,5 +355,5 @@
 !
 !-- Horizontal boundary conditions
-    CALL exchange_horiz( temp, 0, 0 )
+    CALL exchange_horiz( temp )
 
     IF ( bc_lr /= 'cyclic' )  THEN
@@ -627,5 +627,5 @@
 !
 !--       Horizontal boundary conditions
-          CALL exchange_horiz( p_mg, 0, 0 )
+          CALL exchange_horiz( p_mg )
 
           IF ( bc_lr /= 'cyclic' )  THEN
Index: palm/trunk/SOURCE/prandtl_fluxes.f90
===================================================================
--- palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 74)
+++ palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 75)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! moisture renamed humidity
 !
 ! Former revisions:
@@ -97,5 +97,5 @@
 !
 !-- Compute z_p/L (corresponds to the Richardson-flux number)
-    IF ( .NOT. moisture ) THEN
+    IF ( .NOT. humidity )  THEN
        !$OMP PARALLEL DO PRIVATE( k, z_p )
        DO  i = nxl-1, nxr+1
@@ -274,5 +274,5 @@
 !
 !-- If required compute q*
-    IF ( moisture  .OR.  passive_scalar )  THEN
+    IF ( humidity  .OR.  passive_scalar )  THEN
        IF ( constant_waterflux )  THEN
 !
@@ -332,5 +332,5 @@
     CALL exchange_horiz_2d( usws )
     CALL exchange_horiz_2d( vsws )
-    IF ( moisture  .OR.  passive_scalar )  CALL exchange_horiz_2d( qsws )
+    IF ( humidity  .OR.  passive_scalar )  CALL exchange_horiz_2d( qsws )
 
 !
@@ -347,5 +347,5 @@
 !
 !-- Compute the vertical water/scalar flux
-    IF ( .NOT. constant_heatflux .AND. ( moisture .OR. passive_scalar ) ) THEN
+    IF ( .NOT. constant_heatflux .AND. ( humidity .OR. passive_scalar ) ) THEN
        !$OMP PARALLEL DO
        DO  i = nxl-1, nxr+1
Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 74)
+++ palm/trunk/SOURCE/pres.f90	(revision 75)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Volume flow control for non-cyclic boundary conditions added (currently only
+! for the north boundary!!), 2nd+3rd argument removed from exchange horiz
 !
 ! Former revisions:
@@ -54,4 +55,45 @@
        ALLOCATE( d(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
     ENDIF
+
+!
+!-- Conserve the volume flow at the outflow in case of non-cyclic lateral
+!-- boundary conditions
+    IF ( conserve_volume_flow  .AND.  bc_ns == 'radiation/dirichlet')  THEN
+
+       volume_flow(2)   = 0.0
+       volume_flow_l(2) = 0.0
+
+       IF ( nyn == ny )  THEN
+          j = ny+1
+          DO  i = nxl, nxr
+!
+!--          Sum up the volume flow through the north boundary
+             DO  k = nzb_2d(j,i) + 1, nzt
+                volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzu(k)
+             ENDDO
+          ENDDO
+       ENDIF
+#if defined( __parallel )   
+       CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL, &
+                           MPI_SUM, comm1dx, ierr )   
+#else
+       volume_flow = volume_flow_l  
+#endif
+       volume_flow_offset(2) = ( volume_flow_initial(2) - volume_flow(2) )    &
+                               / volume_flow_area(2)                          
+
+       IF ( outflow_n )  THEN
+          j = nyn+1
+          DO  i = nxl, nxr
+             DO  k = nzb_v_inner(j,i) + 1, nzt
+                v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
+             ENDDO
+          ENDDO
+       ENDIF
+
+       CALL exchange_horiz( v )
+
+    ENDIF
+
 
 !
@@ -322,5 +364,5 @@
 !
 !--    Exchange boundaries for p
-       CALL exchange_horiz( tend, 0, 0 )
+       CALL exchange_horiz( tend )
       
     ELSEIF ( psolver == 'sor' )  THEN
@@ -365,6 +407,6 @@
 !-- Correction of the provisional velocities with the current perturbation 
 !-- pressure just computed
-    IF ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic' )  uvmean_outflow_l = 0.0
-    IF ( conserve_volume_flow )  THEN
+    IF ( conserve_volume_flow  .AND. &
+         ( bc_lr == 'cyclic'  .OR.  bc_ns == 'cyclic' ) )  THEN
        volume_flow_l(1) = 0.0
        volume_flow_l(2) = 0.0
@@ -393,36 +435,7 @@
 
 !
-!--       Sum up the horizontal velocity along the outflow plane (in case
-!--       of non-cyclic boundary conditions). The respective mean velocity
-!--       is calculated from this in routine boundary_conds.
-!          IF ( outflow_l  .AND.  i == nxl )  THEN
-!             !$OMP CRITICAL
-!             DO  k = nzb, nzt+1
-!                uvmean_outflow_l(k) = uvmean_outflow_l(k) + v(k,j,nxl)
-!             ENDDO
-!             !$OMP END CRITICAL
-!          ELSEIF ( outflow_r  .AND.  i == nxr )  THEN
-!             !$OMP CRITICAL
-!             DO  k = nzb, nzt+1
-!                uvmean_outflow_l(k) = uvmean_outflow_l(k) + v(k,j,nxr)
-!             ENDDO
-!             !$OMP END CRITICAL
-!          ELSEIF ( outflow_s  .AND.  j == nys )  THEN
-!             !$OMP CRITICAL
-!             DO  k = nzb, nzt+1
-!                uvmean_outflow_l(k) = uvmean_outflow_l(k) + u(k,nys,i)
-!             ENDDO
-!             !$OMP END CRITICAL
-!          ELSEIF ( outflow_n  .AND.  j == nyn )  THEN
-!             !$OMP CRITICAL
-!             DO  k = nzb, nzt+1
-!                uvmean_outflow_l(k) = uvmean_outflow_l(k) + u(k,nyn,i)
-!             ENDDO
-!             !$OMP END CRITICAL
-!          ENDIF
-
-!
 !--       Sum up the volume flow through the right and north boundary
-          IF ( conserve_volume_flow  .AND.  i == nx )  THEN
+          IF ( conserve_volume_flow  .AND.  bc_lr == 'cyclic'  .AND. &
+               i == nx )  THEN
              !$OMP CRITICAL
              DO  k = nzb_2d(j,i) + 1, nzt
@@ -431,5 +444,6 @@
              !$OMP END CRITICAL
           ENDIF
-          IF ( conserve_volume_flow  .AND.  j == ny )  THEN
+          IF ( conserve_volume_flow  .AND.  bc_ns == 'cyclic'  .AND. &
+               j == ny )  THEN
              !$OMP CRITICAL
              DO  k = nzb_2d(j,i) + 1, nzt
@@ -445,5 +459,6 @@
 !
 !-- Conserve the volume flow
-    IF ( conserve_volume_flow )  THEN
+    IF ( conserve_volume_flow  .AND. &
+         ( bc_lr == 'cyclic'  .OR.  bc_ns == 'cyclic' ) )  THEN
 
 #if defined( __parallel )   
@@ -461,10 +476,14 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_u_inner(j,i) + 1, nzt
-                u(k,j,i) = u(k,j,i) + volume_flow_offset(1)
-             ENDDO
-             DO  k = nzb_v_inner(j,i) + 1, nzt
-                v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
-             ENDDO
+             IF ( bc_lr == 'cyclic' )  THEN
+                DO  k = nzb_u_inner(j,i) + 1, nzt
+                   u(k,j,i) = u(k,j,i) + volume_flow_offset(1)
+                ENDDO
+             ENDIF
+             IF ( bc_ns == 'cyclic' )  THEN
+                DO  k = nzb_v_inner(j,i) + 1, nzt
+                   v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
+                ENDDO
+             ENDIF
           ENDDO
        ENDDO
@@ -475,7 +494,7 @@
 !
 !-- Exchange of boundaries for the velocities
-    CALL exchange_horiz( u, uxrp,    0 )
-    CALL exchange_horiz( v,    0, vynp )
-    CALL exchange_horiz( w,    0,    0 )
+    CALL exchange_horiz( u )
+    CALL exchange_horiz( v )
+    CALL exchange_horiz( w )
 
 !
